use strict; # use warnings;

use Irssi ();

use vars qw($VERSION %IRSSI);

$VERSION = '0.1';
%IRSSI = (
	authors => 'Nei',
	contact => 'Nei@QuakeNet',
	name    => 'gainops',
	description => 'Cycle empty channels.',
	license => 'GNU GPLv2 or later',
);

sub lc1459 ($) {
	my $x = shift;
	$x =~ y/A-Z][\^/a-z}{|~/;
	$x
}

use Data::Dumper;

sub sanity_check {
	#print 'server';
	return unless defined $_[0];
	#print 'nick';
	return unless exists $_[0]->{'nick'};
	#print 'nick empty';
	return if $_[0]->{'nick'} eq '';
	#print 'not me';
	return if lc1459($_[0]->{'nick'}) eq lc1459($_[1]);
	#print 'sane';
	1;
}

sub scan_channels {
	return unless sanity_check($_[0], $_[1]);
	for my $ch_obj ($_[0]->channels) {
		check_channel($_[0], $ch_obj, @_[1..3]);
	}
}

sub check_channel {
	#print 'sanity';
	return unless sanity_check($_[0], $_[2]);
	#print 'sane';
	#print 'ch obj';
	my $ch_obj = ref $_[1] ? $_[1] : $_[0]->channel_find($_[1]);
	#print 'ch obj valid';
	return unless defined $ch_obj and ref $ch_obj;
	#print 'preconditions';
	return if ($ch_obj->{'left'} or $ch_obj->{'names_got'} < 1
		or !$ch_obj->{'synced'} or $ch_obj->{'chanop'} or $ch_obj->{'kicked'}
		or !$ch_obj->{'joined'});
	#print '...met';
	my $self;
	#print 'alone?';
	for my $nick_obj ($ch_obj->nicks) {
			#print "compared $nick_obj->{'nick'} with $_[0]->{'nick'}";
		if (lc1459($nick_obj->{'nick'}) eq lc1459($_[0]->{'nick'})) {
			$self = 1;
		}
		else {
			#print 'no';
			return;
		}
	}
	if ($self) {
		#print 'yes';
		$ch_obj->command('cycle');
	}
}

Irssi::signal_add_first({
	'message quit' => sub { my @c = @_; Irssi::timeout_add_once(10, sub { scan_channels(@c) }, undef) },
	'message part' => sub { my @c = @_; Irssi::timeout_add_once(10, sub { check_channel(@c) }, undef) },
});
